
/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * OSOYOO IoT Tutorial: Use OSOYOO IoT APP to  display the status of tilt sensor 
 * remotely connected to the OSOYOO NodeMCU 
 * For more details see: https://osoyoo.com/?p=52702
 */

#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
#ifndef STASSID
#define STASSID "***" // replace *** with your wifi SSID
#define STAPSK  "***" // replace *** with your wifi password
#endif

unsigned int localPort = 8888;      // local port to listen on

// buffers for receiving and sending data
char packetBuffer[UDP_TX_PACKET_MAX_SIZE + 1]; //buffer to hold incoming packet,
//char  ReplyBuffer[] = "acknowledged";       // a string to send back

WiFiUDP Udp;

#define Tiltsensor A0
int threhold=1000; //You can read the dumping thresholds with the example AnologReadSerial
//IPAddress phoneIP=IPAddress(192,168,1,255);//if your Arduino IP is sth like 192.168.0.xx set this value to 192.168.0.255
 
void setup() {
 
  Serial.begin(115200);
  WiFi.mode(WIFI_STA);
  WiFi.begin(STASSID, STAPSK);
  while (WiFi.status() != WL_CONNECTED) {
    Serial.println('.');
    delay(500);
  }
  Serial.print("Connected! IP address: ");
  Serial.println(WiFi.localIP());
  Serial.printf("UDP server on port %d\n", localPort);
  Udp.begin(localPort);
  pinMode(Tiltsensor,INPUT);

}
 
//unsigned long oldTime=0;
//unsigned long currentTime=0;
void loop() {

     int val=analogRead(Tiltsensor);
     String msg = "Status: ";
     //msg= msg+ val;
     if (val<threhold){
     msg = msg + "Down";//when the tilt data value>10
   }
    else{
      msg = msg + "OK";//when the tilt data value<10
    }
     msg += "\n";
     Serial.println(msg);
     delay(1000);

 
// if there's data available, read a packet
 
  int packetSize = Udp.parsePacket();
  if (packetSize) {
    Serial.printf("Received packet of size %d from %s:%d\n    (to %s:%d, free heap = %d B)\n",
                  packetSize,
                  Udp.remoteIP().toString().c_str(), Udp.remotePort(),
                  Udp.destinationIP().toString().c_str(), Udp.localPort(),
                  ESP.getFreeHeap());

    // read the packet into packetBufffer
    int n = Udp.read(packetBuffer, UDP_TX_PACKET_MAX_SIZE);
    packetBuffer[n] = 0;
    Serial.println("Contents:");
    Serial.println(packetBuffer);  
    IPAddress phoneIP=Udp.remoteIP();
    Udp.beginPacket(phoneIP, 8888);
    Udp.write(msg.c_str());
    Udp.endPacket();
    }
}

 
